-- | Clock Control
module CsoundExpr.Opcodes.Control.Clockctl
    (clockoff,
     clockon)
where



import CsoundExpr.Base.Types
import CsoundExpr.Base.MultiOut
import CsoundExpr.Base.SideEffect
import CsoundExpr.Base.UserDefined



-- | * opcode : clockoff
--  
--  
-- * syntax : 
--  
--  >   clockoff inum
--  
--  
-- * description : 
--  
--  Stops one of a number of internal clocks.
--  
--  
-- * url : <http://www.csounds.com/manual/html/clockoff.html>
 
clockoff :: Irate -> SignalOut
clockoff i0num = outOpcode "clockoff" args
  where args = [to i0num]


-- | * opcode : clockon
--  
--  
-- * syntax : 
--  
--  >   clockon inum
--  
--  
-- * description : 
--  
--  Starts one of a number of internal clocks.
--  
--  
-- * url : <http://www.csounds.com/manual/html/clockon.html>
 
clockon :: Irate -> SignalOut
clockon i0num = outOpcode "clockon" args
  where args = [to i0num]