-- | Remote Opcodes
module CsoundExpr.Opcodes.OSCNetwork.Remote
    (remoteport)
where



import CsoundExpr.Base.Types
import CsoundExpr.Base.MultiOut
import CsoundExpr.Base.SideEffect
import CsoundExpr.Base.UserDefined



-- | * opcode : remoteport
--  
--  
-- * syntax : 
--  
--  >   remoteport iportnum
--  
--  
-- * description : 
--  
--  Defines the port for use with the insremot, midremot, insglobal
-- and midglobal opcodes.
--  
--  
-- * url : <http://www.csounds.com/manual/html/remoteport.html>
 
remoteport :: Irate -> SignalOut
remoteport i0portnum = outOpcode "remoteport" args
  where args = [to i0portnum]