module CsoundExpr.Opcodes.Other(
        filebit) 
where

import CsoundExpr.Base.Types
import CsoundExpr.Base.MultiOut
import CsoundExpr.Base.SideEffect
import CsoundExpr.Base.UserDefined


-- | * opcode : filebit
--  
--  
-- * syntax : 
--
-- >ir filebit ifilcod [, iallowraw]
--
-- * description :
--
-- Returns the number of bits in each sample in a sound file.
--
--
-- * url : <http://www.csounds.com/manual/html/filebit.html>
filebit :: [Irate] -> String -> Irate
filebit inits file = opcode "filebit" args
    where args = [to file] ++ map to inits
